commit:     539248ba464c744f81d3c297ee20a061d31e88c1
Author:     Gwendal Grignou <gwendal <AT> chromium <DOT> org>
AuthorDate: Thu May 31 18:39:17 2018 +0000
Commit:     Mike Frysinger <vapier <AT> gentoo <DOT> org>
CommitDate: Thu May 31 18:40:05 2018 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=539248ba
sys-apps/smartmontools: add upstream fix for broadcast nsid on nvme devices

 .../smartmontools-6.6-set-broadcast-nsid.patch     | 104 ++++++++++++++
 sys-apps/smartmontools/smartmontools-6.6-r1.ebuild | 155 +++++++++++++++++++++
 2 files changed, 259 insertions(+)

diff --git 
a/sys-apps/smartmontools/files/smartmontools-6.6-set-broadcast-nsid.patch 
b/sys-apps/smartmontools/files/smartmontools-6.6-set-broadcast-nsid.patch
new file mode 100644
index 00000000000..e65504d43c6
--- /dev/null
+++ b/sys-apps/smartmontools/files/smartmontools-6.6-set-broadcast-nsid.patch
@@ -0,0 +1,104 @@
+fix from upstream
+
+https://www.smartmontools.org/changeset?new=4671@/&old=4670@/
+
+Index: trunk/smartmontools-6.6/ChangeLog
+===================================================================
+ 2017-12-27  Douglas Gilbert  <dgilb...@interlog.com>
+ 
++      nvmecmds.cpp: according to NVMe 1.3a spec, the SMART/
++      health information log page is global and should take
++      the global nsid (all ff_s). It also says the Error
++      info lpage is "global. Broke WD Black PCIe (NVMe)
++      SSD but worked on Intel SSDs. Fix; could break others.
++
++2017-12-27  Douglas Gilbert  <dgilb...@interlog.com>
++
+       os_freebsd.cpp: on error was setting set_nvme_err() to 1,
+       not the actual NVMe status value; fix.
+ 
+Index: trunk/smartmontools-6.6/nvmecmds.cpp
+===================================================================
+diff --git smartmontools-6.6/nvmecmds.cpp smartmontools-6.6/nvmecmds.cpp
+--- smartmontools-6.6/nvmecmds.cpp     (revision 4670)
++++ smartmontools-6.6/nvmecmds.cpp     (revision 4671)
+@@ -196,7 +196,8 @@
+ }
+ 
+ // Read NVMe log page with identifier LID.
+-bool nvme_read_log_page(nvme_device * device, unsigned char lid, void * data, 
unsigned size)
++bool nvme_read_log_page(nvme_device * device, unsigned char lid, void * data,
++                      unsigned size, bool broadcast_nsid)
+ {
+   if (!(4 <= size && size <= 0x4000 && (size % 4) == 0))
+     throw std::logic_error("nvme_read_log_page(): invalid size");
+@@ -204,7 +205,7 @@
+   memset(data, 0, size);
+   nvme_cmd_in in;
+   in.set_data_in(nvme_admin_get_log_page, data, size);
+-  in.nsid = device->get_nsid();
++  in.nsid = broadcast_nsid ? 0xffffffff : device->get_nsid();
+   in.cdw10 = lid | (((size / 4) - 1) << 16);
+ 
+   return nvme_pass_through(device, in);
+@@ -213,7 +214,7 @@
+ // Read NVMe Error Information Log.
+ bool nvme_read_error_log(nvme_device * device, nvme_error_log_page * 
error_log, unsigned num_entries)
+ {
+-  if (!nvme_read_log_page(device, 0x01, error_log, num_entries * 
sizeof(*error_log)))
++  if (!nvme_read_log_page(device, 0x01, error_log, num_entries * 
sizeof(*error_log), true))
+     return false;
+ 
+   if (isbigendian()) {
+@@ -234,7 +235,7 @@
+ // Read NVMe SMART/Health Information log.
+ bool nvme_read_smart_log(nvme_device * device, nvme_smart_log & smart_log)
+ {
+-  if (!nvme_read_log_page(device, 0x02, &smart_log, sizeof(smart_log)))
++  if (!nvme_read_log_page(device, 0x02, &smart_log, sizeof(smart_log), true))
+     return false;
+ 
+   if (isbigendian()) {
+Index: trunk/smartmontools-6.6/nvmecmds.h
+===================================================================
+diff --git smartmontools-6.6/nvmecmds.h smartmontools-6.6/nvmecmds.h
+--- smartmontools-6.6/nvmecmds.h       (revision 4670)
++++ smartmontools-6.6/nvmecmds.h       (revision 4671)
+@@ -248,7 +248,8 @@
+ bool nvme_read_id_ns(nvme_device * device, unsigned nsid, 
smartmontools::nvme_id_ns & id_ns);
+ 
+ // Read NVMe log page with identifier LID.
+-bool nvme_read_log_page(nvme_device * device, unsigned char lid, void * data, 
unsigned size);
++bool nvme_read_log_page(nvme_device * device, unsigned char lid, void * data,
++                      unsigned size, bool broadcast_nsid);
+ 
+ // Read NVMe Error Information Log.
+ bool nvme_read_error_log(nvme_device * device, 
smartmontools::nvme_error_log_page * error_log,
+Index: trunk/smartmontools-6.6/nvmeprint.cpp
+===================================================================
+diff --git smartmontools-6.6/nvmeprint.cpp smartmontools-6.6/nvmeprint.cpp
+--- smartmontools-6.6/nvmeprint.cpp    (revision 4670)
++++ smartmontools-6.6/nvmeprint.cpp    (revision 4671)
+@@ -473,9 +473,21 @@
+   if (options.log_page_size) {
+     // Align size to dword boundary
+     unsigned size = ((options.log_page_size + 4-1) / 4) * 4;
++    bool broadcast_nsid;
+     raw_buffer log_buf(size);
+ 
+-    if (!nvme_read_log_page(device, options.log_page, log_buf.data(), size)) {
++    switch (options.log_page) {
++    case 1:
++    case 2:
++    case 3:
++      broadcast_nsid = true;
++      break;
++    default:
++      broadcast_nsid = false;
++      break;
++    }
++    if (!nvme_read_log_page(device, options.log_page, log_buf.data(),
++                          size, broadcast_nsid)) {
+       pout("Read NVMe Log 0x%02x failed: %s\n\n", options.log_page, 
device->get_errmsg());
+       return retval | FAILSMART;
+     }

diff --git a/sys-apps/smartmontools/smartmontools-6.6-r1.ebuild 
b/sys-apps/smartmontools/smartmontools-6.6-r1.ebuild
new file mode 100644
index 00000000000..06a1bd943db
--- /dev/null
+++ b/sys-apps/smartmontools/smartmontools-6.6-r1.ebuild
@@ -0,0 +1,155 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI="6"
+
+inherit autotools flag-o-matic systemd
+if [[ ${PV} == "9999" ]] ; then
+       
ESVN_REPO_URI="https://svn.code.sf.net/p/smartmontools/code/trunk/smartmontools";
+       ESVN_PROJECT="smartmontools"
+       inherit subversion
+else
+       SRC_URI="mirror://sourceforge/${PN}/${P}.tar.gz"
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~mips ~ppc ~ppc64 
~sparc ~x86 ~x86-fbsd ~amd64-linux ~arm-linux ~x86-linux ~x64-macos"
+fi
+
+DESCRIPTION="Tools to monitor storage systems to provide advanced warning of 
disk degradation"
+HOMEPAGE="https://www.smartmontools.org";
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="caps +daemon selinux static update_drivedb"
+
+DEPEND="
+       caps? (
+               static? ( sys-libs/libcap-ng[static-libs] )
+               !static? ( sys-libs/libcap-ng )
+       )
+       kernel_FreeBSD? (
+               sys-freebsd/freebsd-lib[usb]
+       )
+       selinux? (
+               sys-libs/libselinux
+       )"
+RDEPEND="${DEPEND}
+       daemon? ( virtual/mailx )
+       selinux? ( sec-policy/selinux-smartmon )
+       update_drivedb? (
+               app-crypt/gnupg
+               || (
+                       net-misc/curl
+                       net-misc/wget
+                       www-client/lynx
+                       dev-vcs/subversion
+               )
+       )
+"
+
+REQUIRED_USE="( caps? ( daemon ) )"
+
+PATCHES=(
+       "${FILESDIR}"/${P}-fix-build-on-musl.patch
+       "${FILESDIR}"/${P}-set-broadcast-nsid.patch
+)
+
+src_prepare() {
+       default
+
+       eautoreconf
+}
+
+src_configure() {
+       use static && append-ldflags -static
+       # The build installs /etc/init.d/smartd, but we clobber it
+       # in our src_install, so no need to manually delete it.
+       myeconfargs=(
+               --docdir="${EPREFIX}/usr/share/doc/${PF}"
+               --with-drivedbdir="${EPREFIX}/var/db/${PN}" #575292
+               --with-initscriptdir="${EPREFIX}/etc/init.d"
+               $(use_with caps libcap-ng)
+               $(use_with selinux)
+               --with-systemdsystemunitdir="$(systemd_get_systemunitdir)"
+               $(use_with update_drivedb gnupg)
+               $(use_with update_drivedb update-smart-drivedb)
+       )
+       econf "${myeconfargs[@]}"
+}
+
+src_install() {
+       local db_path="/var/db/${PN}"
+
+       if use daemon; then
+               default
+
+               newinitd "${FILESDIR}"/smartd-r1.rc smartd
+               newconfd "${FILESDIR}"/smartd.confd smartd
+               systemd_newunit "${FILESDIR}"/smartd.systemd smartd.service
+       else
+               dosbin smartctl
+               doman smartctl.8
+
+               local DOCS=( AUTHORS ChangeL* COPYING INSTALL NEWS README TODO )
+               einstalldocs
+       fi
+
+       if use update_drivedb ; then
+               if ! use daemon; then
+                       dosbin "${S}"/update-smart-drivedb
+               fi
+
+               exeinto /etc/cron.monthly
+               doexe "${FILESDIR}/${PN}-update-drivedb"
+       fi
+
+       if use daemon || use update_drivedb; then
+               keepdir "${db_path}"
+
+               # Install a copy of the initial drivedb.h to /usr/share/${PN}
+               # so that we can access that file later in pkg_postinst
+               # even when dealing with binary packages (bug #575292)
+               insinto /usr/share/${PN}
+               doins "${S}"/drivedb.h
+       fi
+
+       # Make sure we never install drivedb.h into the db location
+       # of the acutal image so we don't record hashes because user
+       # can modify that file
+       rm -f "${ED%/}${db_path}/drivedb.h" || die
+
+       # Bug #622072
+       find "${ED%/}"/usr/share/doc -type f -exec chmod a-x '{}' \; || die
+}
+
+pkg_postinst() {
+       if use daemon || use update_drivedb; then
+               local initial_db_file="${EPREFIX%/}/usr/share/${PN}/drivedb.h"
+               local db_path="${EPREFIX%/}/var/db/${PN}"
+
+               if [[ ! -f "${db_path}/drivedb.h" ]] ; then
+                       # No initial database found
+                       cp "${initial_db_file}" "${db_path}" || die
+                       einfo "Default drive database which was shipped with 
this release of ${PN}"
+                       einfo "has been installed to '${db_path}'."
+               else
+                       ewarn "WARNING: There's already a drive database in 
'${db_path}'!"
+                       ewarn "Because we cannot determine if this database is 
untouched"
+                       ewarn "or was modified by the user you have to manually 
update the"
+                       ewarn "drive database:"
+                       ewarn ""
+                       ewarn "a) Replace '${db_path}/drivedb.h' by the 
database shipped with this"
+                       ewarn "   release which can be found in 
'${initial_db_file}', i.e."
+                       ewarn ""
+                       ewarn "     cp \"${initial_db_file}\" \"${db_path}\""
+                       ewarn ""
+                       ewarn "b) Run the following command as root:"
+                       ewarn ""
+                       ewarn "     /usr/sbin/update-smart-drivedb"
+
+                       if ! use update_drivedb ; then
+                               ewarn ""
+                               ewarn "However, 'update-smart-drivedb' requires 
that you re-emerge ${PN}"
+                               ewarn "with USE='update_drivedb'."
+                       fi
+               fi
+       fi
+}

Reply via email to